DECLARE SUB Manage.Palette ()
DECLARE SUB Draw.Palette ()
DECLARE SUB Manage.Grille ()
DECLARE SUB Manage.Pixel (x%, y%)
DECLARE SUB Draw.Pixel (x%, y%)
DECLARE SUB Draw.Grille ()
'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\button.bi'
'$INCLUDE: 'lib\cliczone.bi'
'$INCLUDE: 'lib\status.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\fselect.bi'
'$INCLUDE: 'lib\menu.bi'
'$INCLUDE: 'lib\graphics.bi'

DIM Menu(0 TO 2, 0 TO 6) AS STRING
DIM SHARED IconesClic(0 TO 11) AS clicZone
DIM SHARED couleurs(0 TO 39, 0 TO 39) AS STRING * 1
DIM SHARED SelectedColor AS INTEGER
Menu(1, 0) = "FILE"
        Menu(1, 1) = "New"
        Menu(1, 2) = "Open"
        Menu(1, 3) = "Save"
        Menu(1, 4) = "Save As"
        Menu(1, 5) = "Exit"
        Menu(1, 6) = ""
Menu(2, 0) = ""
xres = 640
yres = 480
fic = FREEFILE
OPEN "docs\cmd.tmp" FOR INPUT AS fic
        INPUT #fic, dat$
CLOSE fic
IF LTRIM$(RTRIM$(dat$)) <> "" THEN filename$ = LTRIM$(RTRIM$(dat$))

SetScreenMode xres, yres, 8


Future.MouseOff
Future.CLS 150
Draw.MenuBar Menu()
Draw.StatusBar "Icone Editor"
Future.MouseON
Draw.Palette
IF filename$ = "" THEN
        GOSUB NewFile
ELSE
                DEF SEG = VARSEG(couleurs(0, 0))
                BLOAD filename$, VARPTR(couleurs(0, 0))
                DEF SEG
                Draw.Grille

END IF
DO
        Manage.Menu Menu()
        Manage.Palette
        IF NOT menufocused THEN Manage.Grille
        IF Menu(0, 1) = "New" THEN GOSUB NewFile
        IF Menu(0, 1) = "Open" THEN GOSUB OpenFile
        IF Menu(0, 1) = "Save" THEN GOSUB SaveFile
        IF Menu(0, 1) = "Save As" THEN GOSUB SaveAs
LOOP UNTIL Menu(0, 1) = "Exit"
ReSetScreen
CHAIN "apps\main.exe"

NewFile:
        filename$ = ""
        FOR x = 0 TO 39
                FOR y = 0 TO 39
                        couleurs(x%, y%) = CHR$(255)
                NEXT y
        NEXT x
        Draw.Grille
RETURN

OpenFile:
        a$ = LTRIM$(RTRIM$(fselect("Open", "ficon.dat")))
        IF a$ <> "" THEN
                filename$ = "DOCS\" + a$
                DEF SEG = VARSEG(couleurs(0, 0))
                BLOAD filename$, VARPTR(couleurs(0, 0))
                DEF SEG
                Draw.Grille
        END IF
RETURN

SaveFile:
        IF filename$ <> "" THEN
                DEF SEG = VARSEG(couleurs(0, 0))
                BSAVE filename$, VARPTR(couleurs(0, 0)), 40 * 40
                DEF SEG
        ELSE
                GOSUB SaveAs
        END IF
RETURN

SaveAs:
        a$ = LTRIM$(RTRIM$(fselect("Save", "ficon.dat")))
        IF a$ <> "" THEN
                filename$ = "DOCS\" + a$
                DEF SEG = VARSEG(couleurs(0, 0))
                BSAVE filename$, VARPTR(couleurs(0, 0)), 40 * 40
                DEF SEG
        END IF
RETURN

SUB Draw.Grille
        
        Draw.Frame 10, 30, 430, 450
        Draw.Frame 500, 270, 600, 370
        Future.MouseOff
        FOR x% = 0 TO 39
                FOR y% = 0 TO 39
                        Draw.Pixel x%, y%
                NEXT y%
        NEXT x%
        Future.MouseON
       
END SUB

SUB Draw.Palette
        Draw.Frame 445, 30, 630, 260

        FOR i% = 0 TO 247
                                IF i < 32 THEN
                                        x% = i% MOD 16
                                        y% = i% \ 16
                                        x1% = 455 + (x% * 10)
                                        y1% = 40 + (y% * 10)
                                        x2% = x1% + 10
                                        y2% = y1% + 10
                                ELSE
                                        x% = (i% - 32) MOD 12
                                        y% = INT((i% - 32) \ 12)
                                        x1% = 458 + (x% * 13)
                                        y1% = 65 + (y% * 8)
                                        x2% = x1% + 13
                                        y2% = y1% + 8

                                END IF
                Future.FILLBOX x1%, y1%, x2%, y2%, i%
                Future.Box x1%, y1%, x2%, y2%, 0
        NEXT i

        Future.FILLBOX 460, 220, 615, 250, SelectedColor
        Future.Box 460, 220, 615, 250, 0

END SUB

SUB Draw.Pixel (x%, y%)
        c% = ASC(couleurs(x%, y%))
        x1% = 20 + x% * 10
        y1% = 40 + y% * 10
        x2% = x1% + 10
        y2% = y1% + 10

        IF c% = 255 THEN
                Future.FILLBOX x1%, y1%, x2%, y2%, 15
                Future.LINE x1%, y1%, x2%, y2%, 0, -1
                Future.LINE x2%, y1%, x1%, y2%, 0, -1
                Future.PSET (530 + x%), (300 + y%), 15
        ELSE
                Future.FILLBOX x1%, y1%, x2%, y2%, c%
                Future.PSET (530 + x%), (300 + y%), c%
        END IF
        Future.Box x1%, y1%, x2%, y2%, 0

END SUB

SUB Manage.Grille
        FOR x% = 0 TO 39
                FOR y% = 0 TO 39
                        Manage.Pixel x%, y%
                NEXT y%
        NEXT x%
END SUB

SUB Manage.Palette

        IF MouseZone(445, 30, 630, 215) THEN
                FOR i% = 0 TO 254
                        IF i% <> SelectedColor THEN
                                IF i < 32 THEN
                                        x% = i% MOD 16
                                        y% = i% \ 16
                                        x1% = 455 + (x% * 10)
                                        y1% = 40 + (y% * 10)
                                        x2% = x1% + 10
                                        y2% = y1% + 10
                                ELSE
                                        x% = (i% - 32) MOD 12
                                        y% = INT((i% - 32) \ 12)
                                        x1% = 458 + (x% * 13)
                                        y1% = 65 + (y% * 8)
                                        x2% = x1% + 13
                                        y2% = y1% + 8
                                 END IF

                                IF MouseZone(x1%, y1%, x2%, y2%) AND MouseClicLeft THEN
                                        SelectedColor = i%
                                        Future.MouseOff
                                        Future.FILLBOX 460, 220, 615, 250, SelectedColor
                                        Future.Box 460, 220, 615, 250, 0
                                        Future.MouseON
                                END IF
                        END IF
                NEXT i%
        END IF

END SUB

SUB Manage.Pixel (x%, y%)
        x1% = 20 + x% * 10
        y1% = 40 + y% * 10
        x2% = x1% + 10
        y2% = y1% + 10
        IF MouseZone(x1%, y1%, x2%, y2%) THEN
                IF MouseClicLeft AND couleurs(x%, y%) <> CHR$(SelectedColor) THEN
                        couleurs(x%, y%) = CHR$(SelectedColor)
                        Future.MouseOff
                        Draw.Pixel x%, y%
                        Future.MouseON
                END IF
                IF MouseClicRight AND couleurs(x%, y%) <> CHR$(255) THEN
                        couleurs(x%, y%) = CHR$(255)
                        Future.MouseOff
                        Draw.Pixel x%, y%
                        Future.MouseON
                END IF
        END IF

       
END SUB

