DECLARE SUB Draw.Title ()
DECLARE FUNCTION MusikLoop% (FileStream AS INTEGER)
'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\fmslib.bi'
'$INCLUDE: 'lib\fs.bi'
'$INCLUDE: 'lib\xpm.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\button.bi'
'$INCLUDE: 'lib\cliczone.bi'
'$INCLUDE: 'lib\status.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\fselect.bi'
'$INCLUDE: 'lib\menu.bi'
'$INCLUDE: 'lib\graphics.bi'

DECLARE SUB DrawChoord (no() AS STRING, oc() AS INTEGER, position AS INTEGER, dur!, count AS INTEGER)
DECLARE SUB playnote (notes() AS STRING, octaves() AS INTEGER, Duration!, tempo%, count)
DECLARE FUNCTION Manage.part$ ()
DECLARE SUB Draw.Frame1 (X1 AS INTEGER, Y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, C1 AS INTEGER, C2 AS INTEGER, e AS INTEGER)
DECLARE FUNCTION Fichier.Save$ ()
DECLARE SUB DrawSilence (num AS INTEGER, duree!)
DECLARE SUB clearnote (numnote AS INTEGER)
DECLARE FUNCTION getval$ (chaine AS STRING, num AS INTEGER)
DECLARE FUNCTION Fichier.Open$ ()
DECLARE SUB fakey (Xpos%, Ypos%, size%)
DECLARE SUB DrawNote (note$, octave%, numnote%, Duration!)
DECLARE SUB DrawPart (Mode$)

DIM winx AS INTEGER, winy AS INTEGER
DIM SHARED winx1 AS INTEGER, winy1  AS INTEGER
DIM SHARED winx2 AS INTEGER, winy2 AS INTEGER
DIM SHARED CurrentPos  AS INTEGER
DIM SHARED CurrentTempo AS INTEGER
DIM SHARED NbrTime AS INTEGER
DIM SHARED titre AS STRING

DIM SHARED Ntime!
DIM SHARED Ndur!

DIM PlayButton AS button
DIM IsPlayed AS INTEGER
DIM IsOpened AS INTEGER
DIM FileStream AS INTEGER
DIM Menu(0 TO 2, 0 TO 3) AS STRING
Menu(1, 0) = "FILE"
	Menu(1, 1) = "Open"
	Menu(1, 2) = "Exit"
	Menu(1, 3) = ""
Menu(2, 0) = ""


winx = 620
winy = 250
winx1 = (640 - winx) / 2
winy1 = 70
winx2 = winx1 + winx
winy2 = winy1 + winy

fic = FREEFILE
OPEN "docs\cmd.tmp" FOR INPUT AS fic
	INPUT #fic, dat$
CLOSE fic
FileName$ = LTRIM$(RTRIM$(dat$))

xres = 640
yres = 480
Set640x480 8


Future.MouseOff
Future.CLS 150
Draw.MenuBar Menu()
Draw.StatusBar "Sheet Music Player"

Draw.Frame winx1, winy1, winx2, winy2
Draw.Title
Future.FILLBOX winx1 + 8, winy2 - 35, winx2 - 8, winy2 - 8, 28
Future.LINE winx1 + 8, winy2 - 35, winx2 - 8, winy2 - 35, 0, -1
create.button PlayButton, winx1 + 11, winy2 - 31, winx1 + 80, winy2 - 11, "Play"
Draw.Frame3 winx1 + 10, winy2 - 32, winx1 + 81, winy2 - 10, -1, 20, 29
draw.button PlayButton
Draw.MenuBar Menu()
DrawPart "start"
IF FileName$ = "" THEN
	Disable.button PlayButton
ELSE
	GOSUB loadfile
END IF
Future.MouseOn
initfms
TIMER ON
DO
	Manage.Menu Menu()
	manage.button PlayButton

	IF PlayButton.Cliqued AND (FileStream > 0) THEN
		IsPlayed = NOT IsPlayed
		IF IsPlayed THEN
			PlayButton.Text$ = "Pause"
			Future.PRINT winx1 + 90, winy2 - 27, "Playing ...", 0, 28
		ELSE
			PlayButton.Text$ = "Play"
			Future.PRINT winx1 + 90, winy2 - 27, "           ", 0, 28
		END IF
		draw.button PlayButton
	END IF
	IF Ntime! > 0 THEN
		Manage.Note Ntime!, Ndur!
	ELSE
		IF IsPlayed THEN
			IF NOT MusikLoop(FileStream) THEN
				CLOSE FileStream
				FileStream = FREEFILE
				OPEN FileName$ FOR INPUT AS FileStream
				IsPlayed = 0
				PlayButton.Text$ = "Play"
				draw.button PlayButton
				Future.PRINT winx1 + 90, winy2 - 27, "           ", 0, 28
				CurrentPos = 0
			END IF
		END IF
	END IF
	IF Menu(0, 1) = "Open" THEN
		a$ = LTRIM$(RTRIM$(Fichier.Open$))
		IF a$ <> "" THEN
			IF FileStream > 0 THEN
				CLOSE FileStream
				FileStream = 0
			END IF
			FileName$ = a$
			GOSUB loadfile
		END IF
	END IF

LOOP UNTIL Menu(0, 1) = "Exit" OR MainWIndow.CloseBTN.Cliqued
ReSetScreen
CHAIN "apps\MusEdit.exe"

loadfile:
	Future.PRINT winx1 + 90, winy2 - 27, "           ", 0, 28
	FileStream = FREEFILE
	OPEN FileName$ FOR INPUT AS FileStream
	Enable.button PlayButton
	NbrTime = 4
	titre = "NoName"
	Draw.Title
	CurrentPos = 0
	CurrentTempo = 80
RETURN

SUB Draw.Title
	C% = 30
	Future.BOX winx1, winy2 + 5, winx2, winy2 + 27, 0
	FOR I% = 0 TO 20
		Future.LINE (winx1 + 1), (winy2 + 6 + I%), (winx2 - 1), (winy2 + 6 + I%), (C% - (I% * .5)), -1
	NEXT I%
	Future.PRINT winx1 + 6, winy2 + 9, titre, 15, -1

END SUB

DEFSNG A-Z
SUB DrawChoord (no() AS STRING, oc() AS INTEGER, position AS INTEGER, dur!, count AS INTEGER)
	maxval = 0
	higestnot = 0
	FOR I = 1 TO count
		valu = ASC(LEFT$(UCASE$(no(I)), 1)) - ASC("C")
		IF valu < 0 THEN valu = 8 + valu
		valu = valu + (oc(I) - 1) * 8
		IF maxval < valu THEN
			maxval = valu
			higestnot = I
		END IF
	NEXT I
	IF dur! >= 1 THEN
		FOR I = 1 TO count
		      DrawNote no(I), oc(I), position, 0 - dur!
		NEXT I
	ELSE
		FOR I = 1 TO count
			a! = 1
			IF I = higestnot THEN a! = dur!
			DrawNote no(I), oc(I), position, 0 - a!
		NEXT I
	END IF
END SUB

DEFINT A-Z
SUB DrawNote (note$, octave%, numnote, dur!)
	Future.MouseOff
	IF UCASE$(LTRIM$(RTRIM$(note$))) = "SILENCE" THEN
		  DrawSilence (numnote), Duration!
	END IF
	SELECT CASE UCASE$(LEFT$(note$, 1))
		CASE "C"
			num = 0
		CASE "D"
			num = 1
		CASE "E"
			num = 2
		CASE "F"
			num = 3
		CASE "G"
			num = 4
		CASE "A"
			num = 5
		CASE "B"
			num = 6
	END SELECT
	num = num + (octave% - 1) * 7
	Ypos = 270 - (num * 5)
	Xpos = 90 + numnote * 30
	Future.CIRCLE Xpos, Ypos, 5, 0
	Duration! = ABS(dur!)
	IF Duration! >= 2 THEN Future.CIRCLE Xpos, Ypos, 4, 0
	IF Duration! = 3 OR Duration! = 1.5 OR Duration! = .75 OR (Duration >= .35 AND Duration <= .38) THEN
		Future.FILLCIRCLE (Xpos + 12), (Ypos - 3), 2, 0
	END IF
	IF Duration! < 4 THEN
		IF octave% < 4 OR dur! < 0 THEN
			Future.FILLBOX (Xpos + 5), (Ypos - 30), (Xpos + 6), (Ypos), 0
		ELSE
			Future.FILLBOX (Xpos - 5), (Ypos), (Xpos - 6), (Ypos + 30), 0
		END IF

		IF Duration! < 2 THEN
			Future.FILLCIRCLE Xpos, Ypos, 5, 0
			IF Duration! < 1 THEN
				IF octave% < 4 OR dur! < 0 THEN
					Future.LINE (Xpos + 6), (Ypos - 30), (Xpos + 15), (Ypos - 25), 0, -1
					Future.LINE (Xpos + 6), (Ypos - 29), (Xpos + 15), (Ypos - 24), 0, -1
				ELSE
					Future.LINE (Xpos - 6), (Ypos + 30), (Xpos + 3), (Ypos + 25), 0, -1
					Future.LINE (Xpos - 6), (Ypos + 29), (Xpos + 3), (Ypos + 24), 0, -1
				END IF
				IF Duration! < .5 THEN
					IF octave% < 4 OR dur! < 0 THEN
						Future.LINE (Xpos + 6), (Ypos - 25), (Xpos + 15), (Ypos - 20), 0, -1
						Future.LINE (Xpos + 6), (Ypos - 24), (Xpos + 15), (Ypos - 19), 0, -1
					ELSE
						Future.LINE (Xpos - 6), (Ypos + 25), (Xpos + 3), (Ypos + 20), 0, -1
						Future.LINE (Xpos - 6), (Ypos + 24), (Xpos + 3), (Ypos + 19), 0, -1

					END IF
				END IF
			END IF
		END IF
	END IF
	
	IF (num MOD 2) = 0 THEN
		Future.LINE (Xpos - 10), (270 - (num * 5)), (Xpos + 10), (270 - (num * 5)), 0, -1
	END IF
	FOR I = num + (num MOD 2) TO 4 STEP 2
	       Future.LINE (Xpos - 10), (270 - (I * 5)), (Xpos + 10), (270 - (I * 5)), 0, -1
	NEXT I
	FOR I = num - (num MOD 2) TO 24 STEP -2
		Future.LINE (Xpos - 10), (270 - (I * 5)), (Xpos + 10), (270 - (I * 5)), 0, -1
	NEXT I

       
	IF (MID$(note$, 2, 1)) = "#" THEN
		Future.LINE (Xpos - 7), (Ypos - 10), (Xpos - 7), (Ypos - 1), 0, -1
		Future.LINE (Xpos - 12), (Ypos - 10), (Xpos - 12), (Ypos - 1), 0, -1
	       
		Future.LINE (Xpos - 5), (Ypos - 8), (Xpos - 14), (Ypos - 8), 0, -1
		Future.LINE (Xpos - 5), (Ypos - 3), (Xpos - 14), (Ypos - 3), 0, -1
	END IF
	IF LCASE$((MID$(note$, 2, 1))) = "b" THEN
		Future.PRINT (Xpos - 11), (Ypos - 15), "b", 0, -1
	END IF
	Future.CIRCLE Xpos, Ypos, 5, 7
	Future.MouseOn
END SUB

SUB DrawPart (Mode$)
	Future.MouseOff
	IF LCASE$(Mode$) = "start" THEN
	Future.FILLBOX (winx1 + 8), (winy1 + 8), (winx2 - 8), (winy2 - 36), 15
	FOR I = 0 TO 4
		Future.LINE (winx1 + 10), (150 + (I * 10)), (winx2 - 10), (150 + (I * 10)), 0, -1
		Future.LINE (winx1 + 10), (210 + (I * 10)), (winx2 - 10), (210 + (I * 10)), 0, -1
	NEXT I
	Future.LINE (winx1 + 10), 200, (winx2 - 10), 200, 0, &HF0F0

	LoadXPM GetFileName("ficon.dat", "solkey"), winx1 + 15, 150
	LoadXPM GetFileName("ficon.dat", "fakey"), winx1 + 15, 210

	ELSE
		Future.FILLBOX (winx1 + 60), (winy1 + 8), (winx2 - 8), (winy2 - 36), 15
		FOR I = 0 TO 4
			Future.LINE (winx1 + 10), (150 + (I * 10)), (winx2 - 10), (150 + (I * 10)), 0, -1
			Future.LINE (winx1 + 10), (210 + (I * 10)), (winx2 - 10), (210 + (I * 10)), 0, -1
		NEXT I
		Future.LINE (winx1 + 10), 200, (winx2 - 10), 200, 0, &HF0F0
	END IF
	Future.MouseOn
END SUB

DEFSNG A-Z
SUB DrawSilence (num AS INTEGER, duree!)
	Xpos = 90 + num * 30
	Ypos = 200

	Future.MouseOff
	IF duree < 2 THEN
		IF duree < 1 THEN
			Future.LINE (Xpos + 5), (Ypos - 15), (Xpos - 5), (Ypos + 15), 0, -1
			Future.BOX (Xpos - 13), (Ypos - 15), (Xpos + 5), (Ypos - 14), 0
			IF duree < .5 THEN
				Future.BOX (Xpos - 13), (Ypos - 8), (Xpos + 3), (Ypos - 7), 0
			END IF
		ELSE
			LoadXPM GetFileName("ficon.dat", "silence1"), Xpos - 20, 150
		'        PSET (xpos, ypos - 15), 10
		'        DRAW "c10G2D1F4D2G4D2F3D3G2D2F2G1D2"
		END IF
	ELSE
		IF duree >= 4 THEN Ypos = Ypos + 5
		Future.FILLBOX (Xpos - 10), (Ypos - 5), (Xpos + 10), Ypos, 0
	END IF

	IF duree! = 3 OR duree! = 1.5 OR duree! = .75 OR duree! = .375 THEN
		Future.FILLCIRCLE (Xpos + 14), (Ypos - 6), 2, 0
	END IF
	Future.MouseOn
END SUB

FUNCTION Fichier.Open$
	document$ = fselect("Open", "fmusic.dat")
	IF document$ <> "" THEN
	 Fichier.Open$ = "DOCS\" + LCASE$(LTRIM$(RTRIM$(document$)))
	ELSE
	 Fichier.Open$ = ""
	END IF
END FUNCTION

FUNCTION getval$ (chaine AS STRING, num AS INTEGER)
	a$ = LTRIM$(RTRIM$(chaine$)) + ","
	Retval$ = ""
	currentnum = 1
	curpos = 1
	debutchaine = 1
	FOR I = 1 TO LEN(a$)
		IF MID$(a$, I, 1) = "," THEN
				IF currentnum = num THEN
					Retval$ = MID$(a$, debutchaine, I - debutchaine)
					getval$ = Retval$
					EXIT FUNCTION
				ELSE
					debutchaine = I + 1
					currentnum = currentnum + 1
				END IF
			
		END IF
	NEXT I

	

END FUNCTION

DEFINT A-Z
FUNCTION MusikLoop (FileStream AS INTEGER)
DIM no(1 TO 3) AS STRING
DIM oc(1 TO 3) AS INTEGER
DIM count AS INTEGER

	Retval = -1
	count = 0
	Duration! = 0
	IF NOT EOF(FileStream) THEN
		LINE INPUT #FileStream, ligne$
		action$ = LTRIM$(RTRIM$(UCASE$(getval(ligne$, 1))))
		IF LEN(action$) > 0 THEN
		SELECT CASE action$
			CASE "TITRE"
			      titre = getval$(ligne$, 2)
			      Draw.Title
			CASE "TIME"
			      NbrTime = VAL(getval$(ligne$, 2))
			      IF CurrentPos >= (NbrTime * 4) THEN CurrentPos = 0
			CASE "TEMPO"
			      CurrentTempo = VAL(getval$(ligne$, 2))
			CASE "SILENCE"
			      IF CurrentPos = 0 THEN DrawPart ""
			      Duration! = VAL(getval$(ligne$, 2))
			      DrawSilence CurrentPos, Duration!
			      Ndur! = (60 / CurrentTempo) * Duration!
			      Ntime! = TIMER
			CASE "CHOORD"
			      count = VAL(getval$(ligne$, 2))
			      IF count >= 1 AND count <= 3 THEN
				IF CurrentPos = 0 THEN DrawPart ""
				FOR I% = 1 TO count
					j% = (I% * 2) + 1
					no(I%) = getval$(ligne$, j)
					oc(I%) = VAL(getval$(ligne$, j + 1))
				NEXT I%
				Duration! = VAL(getval$(ligne$, (count * 2) + 3))
				playnote no(), oc(), Duration!, CurrentTempo, count
				Ndur! = (60 / CurrentTempo) * Duration!
				Ntime! = TIMER
				DrawChoord no(), oc(), CurrentPos, Duration!, count
			      ELSE
				count = 0
			      END IF
			CASE ELSE
				'c'est donc une note
				'on verifie la validit (lettre comprise entre "A" et "G", suivit ou non de "#" ou "B")
				ok = 1
				IF (ASC(LEFT$(action$, 1)) < ASC("A")) AND (ASC(LEFT$(action$, 1)) > ASC("G")) THEN ok = 0
				IF LEN(action$) = 2 AND MID$(action$, 2, 1) <> "#" AND MID$(action$, 2, 1) <> "B" THEN ok = 0
				IF LEN(action$) < 1 OR LEN(action$) > 2 THEN ok = 0
				IF ok = 1 THEN
					IF CurrentPos = 0 THEN DrawPart ""
					no(1) = action$
					oc(1) = VAL(getval$(ligne$, 2))
					Duration! = VAL(getval$(ligne$, 3))
					count = 1
					playnote no(), oc(), Duration!, CurrentTempo, 1
					Ndur! = (60 / CurrentTempo) * Duration!
					Ntime! = TIMER
					DrawNote no(1), oc(1), CurrentPos, Duration!
				END IF
		END SELECT
		IF Duration! > 0 THEN
			CurrentPos = (CurrentPos + INT(Duration! / .25))
			IF CurrentPos >= (NbrTime * 4) THEN CurrentPos = 0
		END IF
		END IF
	ELSE
		Retval = 0
	END IF
	MusikLoop = Retval
END FUNCTION

