DECLARE SUB binwriteline (handler%, chaine$)
DECLARE SUB Manage.Grille ()
DECLARE SUB Draw.Grille ()
DECLARE SUB Draw.Char (x AS INTEGER, y AS INTEGER)
DECLARE SUB Manage.Panel ()
DECLARE SUB Draw.Panel ()
DECLARE SUB Manage.CharSet ()
DECLARE SUB Draw.CharSet ()
'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\button.bi'
'$INCLUDE: 'lib\cliczone.bi'
'$INCLUDE: 'lib\status.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\fselect.bi'
'$INCLUDE: 'lib\menu.bi'
'$INCLUDE: 'lib\graphics.bi'

CONST MaxX = 69
CONST MaxY = 7
TYPE Character
        asciicode AS INTEGER
        bgcolor AS INTEGER
        fgcolor AS INTEGER
END TYPE
ON ERROR GOTO gestionerreur
DIM SHARED characters(0 TO MaxX, 0 TO MaxY) AS Character
DIM menu(0 TO 3, 0 TO 6) AS STRING
DIM SHARED winx1 AS INTEGER
DIM SHARED winy1 AS INTEGER
DIM SHARED winx2 AS INTEGER
DIM SHARED winy2 AS INTEGER
DIM SHARED SelectedChar
DIM SHARED fgcolor AS INTEGER
DIM SHARED bgcolor AS INTEGER
DIM filename AS STRING

fic = FREEFILE
OPEN "docs\cmd.tmp" FOR INPUT AS fic
        INPUT #fic, dat$
CLOSE fic
filename$ = LTRIM$(RTRIM$(dat$))


menu(1, 0) = "FILE"
        menu(1, 1) = "New"
        menu(1, 2) = "Open"
        menu(1, 3) = "Save"
        menu(1, 4) = "Save As"
        menu(1, 5) = "Exit"
        menu(1, 6) = ""
menu(2, 0) = "Exportation"
        menu(2, 1) = "Export"
        menu(2, 2) = ""
menu(3, 0) = ""
xres = 640
yres = 480
winx = (MaxX * 8) + 20
winy = (MaxY * 16) + 20
winx1 = (xres - winx) / 2
winy1 = 50'(yres - winy) / 2
winx2 = winx1 + winx
winy2 = winy1 + winy

SetScreenMode xres, yres, 8
Future.MouseOff
Future.CLS 150
Draw.MenuBar menu()
Draw.StatusBar ""
Draw.Frame winx1, winy1, winx2, winy2
Draw.CharSet
Draw.Panel

IF filename = "" THEN
        GOSUB FileNew
ELSE
        GOSUB loadfile
END IF
Future.MouseON
DO
       
        Manage.Menu menu()
        Manage.CharSet
        Manage.Panel
        Manage.Grille
        IF menu(0, 1) = "New" THEN GOSUB FileNew
        IF menu(0, 1) = "Open" THEN GOSUB FileOpen
        IF menu(0, 1) = "Save" THEN GOSUB FileSave
        IF menu(0, 1) = "Save As" THEN GOSUB fileSaveAs
        IF menu(0, 1) = "Export" THEN GOSUB FileExport

LOOP UNTIL menu(0, 1) = "Exit"
Future.MouseOff
ReSetScreen
CHAIN "apps\main.exe"
END



FileNew:
        FOR x = 0 TO MaxX - 1
                FOR y = 0 TO MaxY - 1
                        characters(x, y).asciicode = 0
                        characters(x, y).fgcolor = 0
                        characters(x, y).bgcolor = 0
                        Draw.Char x, y
                NEXT y
        NEXT x
RETURN

FileOpen:
        a$ = fselect("Open", "fbanner.dat")
        IF a$ <> "" THEN
                filename = "Docs\" + a$
                GOSUB loadfile
        END IF

RETURN

FileSave:
        IF filename = "" THEN
                GOSUB fileSaveAs
        ELSE
        END IF
        
RETURN

fileSaveAs:
        a$ = fselect("Save", "fbanner.dat")
        IF a$ <> "" THEN
                filename = "Docs\" + a$
                fic = FREEFILE
                OPEN filename FOR BINARY AS fic
                        FOR x = 0 TO MaxX - 1
                                FOR y = 0 TO MaxY - 1
                                        PUT #fic, , characters(x, y)
                                NEXT y
                        NEXT x
                CLOSE fic
               
        END IF
RETURN
DIM chara AS STRING * 1
FileExport:

        a$ = fselect("Save", "fqml.dat")
        IF a$ <> "" THEN
                filename = "Docs\" + a$
                KILL filename
                fic = FREEFILE
                OPEN filename FOR BINARY AS fic
                   '     binwriteline fic, "!QML Banner generated by Qbanner"
                        binwriteline fic, "!" + DATE$
                        binwriteline fic, "F0"
                        binwriteline fic, "B15"
                        FOR y = 0 TO MaxY - 1
                                FOR x = 0 TO MaxX - 1
                                        IF characters(x, y).asciicode <> 0 THEN
                                                IF (x > 1) THEN
                                                        IF characters(x, y).fgcolor <> characters(x - 1, y).fgcolor THEN
                                                                binwriteline fic, "#" + LTRIM$(RTRIM$(STR$(characters(x, y).fgcolor)))
                                                        END IF
                                                        IF characters(x, y).bgcolor <> characters(x - 1, y).bgcolor THEN
                                                                binwriteline fic, ":" + LTRIM$(RTRIM$(STR$(characters(x, y).bgcolor)))
                                                        END IF
                                                ELSE
                                                         binwriteline fic, "#" + LTRIM$(RTRIM$(STR$(characters(x, y).fgcolor)))
                                                        binwriteline fic, ":" + LTRIM$(RTRIM$(STR$(characters(x, y).bgcolor)))
                                                END IF
                                                binwriteline fic, "c" + LTRIM$(RTRIM$(STR$(characters(x, y).asciicode)))
                                        ELSE
                                                IF (x > 1) THEN
                                                        IF characters(x - 1, y).asciicode <> 0 THEN
                                                         binwriteline fic, "#"
                                                         binwriteline fic, ":"
                                                        END IF
                                                END IF
                                                binwriteline fic, "$ "
                                                
                                        END IF
                                NEXT x
                                binwriteline fic, "|"
                        NEXT y
                        
                CLOSE fic
        END IF
RETURN

loadfile:
                fic = FREEFILE
                OPEN filename FOR BINARY AS fic
                        FOR x = 0 TO MaxX - 1
                                FOR y = 0 TO MaxY - 1
                                        GET #fic, , characters(x, y)
                                        Draw.Char x, y
                                NEXT y
                        NEXT x
                CLOSE fic
RETURN



gestionerreur:
        RESUME NEXT

SUB binwriteline (handler%, chaine$)
DIM cara AS STRING * 1
        FOR i = 1 TO LEN(chaine$)
                cara = MID$(chaine$, i, 1)
                PUT #handler%, , cara
        NEXT i
        cara = CHR$(13)
        PUT #handler%, , cara
END SUB

SUB Draw.Char (x AS INTEGER, y AS INTEGER)
Future.MouseOff
        IF characters(x, y).asciicode = 0 THEN
                Future.FILLBOX (winx1 + 10 + (x * 8)), (winy1 + 10 + (y * 16)), (winx1 + 17 + (x * 8)), (winy1 + 25 + (y * 16)), 15
                Future.Box (winx1 + 10 + (x * 8)), (winy1 + 10 + (y * 16)), (winx1 + 17 + (x * 8)), (winy1 + 25 + (y * 16)), 7
        ELSE
                Future.PRINT (winx1 + 10 + (x * 8)), (winy1 + 10 + (y * 16)), CHR$(characters(x, y).asciicode), (characters(x, y).fgcolor), (characters(x, y).bgcolor)
        END IF
Future.MouseON
END SUB

SUB Draw.CharSet
        Draw.Frame winx1, winy2 + 20, winx1 + (52 * 8) + 20, winy2 + (5 * 16) + 40
        Future.MouseOff
        FOR i = 0 TO 255
                xpos = i MOD 52
                ypos = i \ 52
                c1 = 15 * ABS(SelectedChar = i)
                c2 = 15 * ABS(SelectedChar <> i)
                Future.PRINT ((xpos * 8) + winx1 + 10), ((ypos * 16) + winy2 + 30), CHR$(i), (c1), (c2)
        NEXT i
Future.MouseON
END SUB

SUB Draw.Grille
        FOR x = 0 TO MaxX - 1
        FOR y = 0 TO MaxY - 1
                Draw.Char x, y
        NEXT y
        NEXT x
END SUB

SUB Draw.Panel
        Draw.Frame winx1, winy2 + 140, winx2, winy2 + 220
        Future.MouseOff
        Future.PRINT winx1 + 10, winy2 + 158, "FG color :", 0, 15
        Future.PRINT winx1 + 10, winy2 + 188, "BG color :", 0, 15
        FOR i = 0 TO 15
                xpos = winx1 + 100 + (i * 25)
                Future.FILLBOX xpos, winy2 + 155, xpos + 20, winy2 + 175, i
                Future.FILLBOX xpos, winy2 + 185, xpos + 20, winy2 + 205, i
                Future.Box xpos, winy2 + 155, xpos + 20, winy2 + 175, 0
                Future.Box xpos, winy2 + 185, xpos + 20, winy2 + 205, 0
        NEXT i
        Future.FILLBOX winx2 - 70, winy2 + 155, winx2 - 15, winy2 + 175, fgcolor
        Future.FILLBOX winx2 - 70, winy2 + 185, winx2 - 15, winy2 + 205, bgcolor
        Future.Box winx2 - 70, winy2 + 155, winx2 - 15, winy2 + 175, 0
        Future.Box winx2 - 70, winy2 + 185, winx2 - 15, winy2 + 205, 0
        Future.MouseON
END SUB

SUB Manage.CharSet
        FOR i = 0 TO 255
                xpos = i MOD 52
                ypos = i \ 52
                c1 = 15 * ABS(SelectedChar = i)
                c2 = 15 * ABS(SelectedChar <> i)
                IF MouseZone(((xpos * 8) + winx1 + 10), ((ypos * 16) + winy2 + 30), ((xpos * 8) + winx1 + 17), ((ypos * 16) + winy2 + 45)) AND MouseClicLeft THEN
                        Future.MouseOff
                        jxpos = SelectedChar MOD 52
                        jYpos = SelectedChar \ 52
                        Future.PRINT ((jxpos * 8) + winx1 + 10), ((jYpos * 16) + winy2 + 30), CHR$(SelectedChar), 0, 15
                        SelectedChar = i
                        jxpos = SelectedChar MOD 52
                        jYpos = SelectedChar \ 52
                        Future.PRINT ((jxpos * 8) + winx1 + 10), ((jYpos * 16) + winy2 + 30), CHR$(SelectedChar), (fgcolor), (bgcolor)
                        Future.MouseON

                END IF

        NEXT i

END SUB

SUB Manage.Grille
        FOR x = 0 TO MaxX - 1
                FOR y = 0 TO MaxY - 1
                        xpos = winx1 + 10 + x * 8
                        ypos = winy1 + 10 + y * 16
                        IF MouseZone(xpos, ypos, xpos + 7, ypos + 15) THEN
                              IF MouseClicLeft THEN
                                characters(x, y).asciicode = SelectedChar
                                characters(x, y).bgcolor = bgcolor
                                characters(x, y).fgcolor = fgcolor
                                Draw.Char x, y
                              END IF
                              IF MouseClicRight THEN
                                characters(x, y).asciicode = 0
                                characters(x, y).bgcolor = 0
                                characters(x, y).fgcolor = 0
                                Draw.Char x, y
                              END IF


                        END IF
                NEXT y
        NEXT x
END SUB

SUB Manage.Panel
        FOR i = 0 TO 15
                xpos = winx1 + 100 + (i * 25)
                IF MouseZone(xpos, winy2 + 155, xpos + 20, winy2 + 175) AND MouseClicLeft AND fgcolor <> i THEN
                        fgcolor = i
                        Future.FILLBOX winx2 - 70, winy2 + 155, winx2 - 15, winy2 + 175, fgcolor
                        Future.Box winx2 - 70, winy2 + 155, winx2 - 15, winy2 + 175, 0
                        jxpos = SelectedChar MOD 52
                        jYpos = SelectedChar \ 52
                        Future.PRINT ((jxpos * 8) + winx1 + 10), ((jYpos * 16) + winy2 + 30), CHR$(SelectedChar), (fgcolor), (bgcolor)

                END IF
                IF MouseZone(xpos, winy2 + 185, xpos + 20, winy2 + 205) AND MouseClicLeft AND bgcolor <> i THEN
                        bgcolor = i
                        Future.FILLBOX winx2 - 70, winy2 + 185, winx2 - 15, winy2 + 205, bgcolor
                        Future.Box winx2 - 70, winy2 + 185, winx2 - 15, winy2 + 205, 0
                        jxpos = SelectedChar MOD 52
                        jYpos = SelectedChar \ 52
                        Future.PRINT ((jxpos * 8) + winx1 + 10), ((jYpos * 16) + winy2 + 30), CHR$(SelectedChar), (fgcolor), (bgcolor)
                END IF
        NEXT i
        
        
        
        
END SUB

