'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\button.bi'

DEFSNG A-Z
SUB create.button (Button AS Button, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, text AS STRING)
	Button.x1 = x1
	Button.y1 = y1
	Button.x2 = x2
	Button.y2 = y2
	Button.pressed = 0
	Button.Cliqued = 0
	Button.text = text
	Button.Enabled = -1
END SUB

DEFINT A-Z
SUB Disable.button (Button AS Button)
	Button.Enabled = 0
	draw.button Button
	Button.Cliqued = 0
END SUB

DEFSNG A-Z
SUB draw.button (Button AS Button)
DEFINT A-Z
Future.MouseOff
texte$ = LTRIM$(RTRIM$(Button.text$))
IF (Button.x2 - Button.x1 - 8) < LEN(texte$) * 8 THEN texte$ = LEFT$(texte$, ((Button.x2 - Button.x1 - 8) / 8))

	IF Button.pressed THEN
		C1% = 20
		C2% = 30
	ELSE
		C1% = 30
		C2% = 20
	END IF

	C! = C1%
	cadd! = (C2% - C1%) / (Button.y2 - Button.y1)
	FOR Y% = Button.y1% TO Button.y2%
		Future.LINE Button.x1% + 1, Y%, Button.x2% - 1, Y%, INT(C!), -1
		R = R + radd: G = G + gadd: B = B + badd
		C! = C! + cadd!
	NEXT Y%
	Future.Box Button.x1, Button.y1, Button.x2, Button.y2, 0
	IF Button.Enabled THEN
		c4 = 15
	ELSE
		c4 = 28
	END IF
	Future.PRINT (((Button.x2 + Button.x1 - (LEN(texte$) * 8)) / 2) + ABS(Button.pressed)), (((Button.y2 + Button.y1 - 14) / 2) + ABS(Button.pressed)), texte$, (c4), -1

	     Future.LINE (Button.x1 + 1), (Button.y1 + 1), (Button.x1 + 1), (Button.y2 - 1), C1%, -1
	     Future.LINE (Button.x1 + 1), (Button.y1 + 1), (Button.x2 - 1), (Button.y1 + 1), C1%, -1
	     Future.LINE (Button.x2 - 1), (Button.y2 - 1), (Button.x1 + 1), (Button.y2 - 1), C2%, -1
	     Future.LINE (Button.x2 - 1), (Button.y2 - 1), (Button.x2 - 1), (Button.y1 + 1), C2%, -1
	
Future.MouseON
END SUB

SUB Enable.button (Button AS Button)
	Button.Enabled = -1
	draw.button Button
END SUB

DEFSNG A-Z
SUB manage.button (Button AS Button)
DIM OldState AS INTEGER
	IF NOT Button.Enabled THEN EXIT SUB
	OldState = Button.pressed
	NewState = MouseZone(Button.x1, Button.y1, Button.x2, Button.y2) AND MouseClicLeft
	IF NewState <> OldState THEN
				Button.pressed = NewState
				draw.button Button
	END IF
	Button.Cliqued = (OldState = -1) AND (NewState = 0) AND (MouseClicLeft = 0)
END SUB

