'$INCLUDE: 'lib\fs.bi'

SUB ClearClass (catfile$)
        fic = FREEFILE
        OPEN "docs\" + catfile$ FOR INPUT AS fic
                INPUT #fic, nbrfic
                FOR i = 1 TO nbrfic
                        INPUT #fic, rname$
                        INPUT #fic, sname$
                        KILL "docs\" + rname$
                NEXT i
        CLOSE fic
        OPEN "docs\" + catfile$ FOR OUTPUT AS fic
                PRINT #fic, 0
        CLOSE fic
END SUB

SUB ClearTrash
        fic = FREEFILE
        OPEN "docs\trash.dat" FOR INPUT AS fic
                INPUT #fic, nbrfiles
                FOR i = 1 TO nbrfiles
                        INPUT #fic, rname$
                        INPUT #fic, sname$
                        INPUT #fic, cname$
                        IF LCASE$(LEFT$(rname$, 7)) <> "http://" THEN KILL "docs\" + rname$
                NEXT i
        CLOSE fic
        OPEN "docs\trash.dat" FOR OUTPUT AS fic
                PRINT #fic, 0
        CLOSE fic
        
END SUB

SUB CreateClass (classname$, classprog$, classicon$, classcat$)
        Ok = 1
        fic = FREEFILE
        OPEN "docs\cats.dat" FOR INPUT AS fic
                INPUT #fic, nbrclass
                FOR i = 1 TO nbrclass
                        INPUT #fic, cname$
                        INPUT #fic, cprog$
                        INPUT #fic, cicon$
                        INPUT #fic, ccat$
                        IF cname$ = classname$ OR ccat$ = classcat$ THEN
                                Ok = 0
                                EXIT FOR
                        END IF
                NEXT i
        CLOSE fic

        IF Ok = 0 THEN EXIT SUB
        fic = FREEFILE
        OPEN "Docs\cats.dat" FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "docs\cats.tmp" FOR OUTPUT AS fic2
                INPUT #fic, nbrclass
                PRINT #fic2, nbrclass + 1
                FOR i = 1 TO nbrclass
                        INPUT #fic, cname$
                        INPUT #fic, cprog$
                        INPUT #fic, cicon$
                        INPUT #fic, ccat$
                        PRINT #fic2, cname$
                        PRINT #fic2, cprog$
                        PRINT #fic2, cicon$
                        PRINT #fic2, ccat$
                NEXT i
                PRINT #fic2, classname$
                PRINT #fic2, classprog$
                PRINT #fic2, classicon$
                PRINT #fic2, classcat$
        CLOSE fic2
        CLOSE fic
        KILL "docs\cats.dat"
        SHELL "copy docs\cats.tmp docs\cats.dat"
        KILL "docs\cats.tmp"
        fic = FREEFILE
        OPEN "docs\" + classcat$ FOR OUTPUT AS fic
                PRINT #fic, 0
        CLOSE fic
END SUB

FUNCTION CreateFile$ (catfile$, symname$)
Ok = 1
        fic = FREEFILE
        OPEN "docs\docs.dat" FOR INPUT AS fic
                INPUT #fic, numfile
        CLOSE fic
        numfile = numfile + 1
        OPEN "docs\docs.dat" FOR OUTPUT AS fic
                PRINT #fic, numfile
        CLOSE fic
        filename$ = LTRIM$(RTRIM$(STR$(numfile))) + ".dat"
        fic = FREEFILE
        OPEN "docs\" + catfile$ FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\docs.tmp" FOR OUTPUT AS fic2
                        INPUT #fic, nbrfiles
                        PRINT #fic2, nbrfiles + 1

                        FOR za = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                IF sname$ = symname$ THEN Ok = 0
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                        NEXT za
                        PRINT #fic2, filename$
                        PRINT #fic2, symname$
                CLOSE fic2
        CLOSE fic
        IF Ok = 0 THEN
                KILL "docs\docs.tmp"
                CreateFile = ""
                EXIT FUNCTION
        END IF

        fic = FREEFILE
        OPEN "docs\" + catfile$ FOR OUTPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\docs.tmp" FOR INPUT AS fic2
                        INPUT #fic2, nbrfiles
                        PRINT #fic, nbrfiles
                        FOR za = 1 TO nbrfiles
                                INPUT #fic2, rname$
                                INPUT #fic2, sname$
                                PRINT #fic, rname$
                                PRINT #fic, sname$
                        NEXT za
                CLOSE fic2
        CLOSE fic
        KILL "docs\docs.tmp"
        CreateFile = filename$
END FUNCTION

SUB DeleteFile (catfile$, symname$)
        fic = FREEFILE
        retval$ = ""
        OPEN "docs\" + catfile$ FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "docs.tmp" FOR OUTPUT AS fic2
        INPUT #fic, nbrfiles
        FOR i = 1 TO nbrfiles
                INPUT #fic, rname$
                INPUT #fic, sname$
                IF LTRIM$(RTRIM$(sname$)) = LTRIM$(RTRIM$(symname$)) THEN
                        retval$ = "DOCS\" + LTRIM$(RTRIM$(rname$))
                ELSE
                        PRINT #fic2, rname$
                        PRINT #fic2, sname$
                END IF
        NEXT i
        CLOSE fic
        CLOSE fic2

        IF retval$ <> "" THEN
                nbrfiles = nbrfiles - 1
                fic = FREEFILE
                OPEN "docs.tmp" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\" + catfile$ FOR OUTPUT AS fic2
                        PRINT #fic2, nbrfiles
                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                        NEXT i
                CLOSE fic2
                CLOSE fic
                KILL "docs.tmp"
                KILL "docs\" + retval$
         END IF


END SUB

FUNCTION GetFileName$ (catfile$, symname$)
        fic = FREEFILE
        retval$ = ""
        OPEN "docs\" + catfile$ FOR INPUT AS fic
        INPUT #fic, nbrfiles
        FOR i = 1 TO nbrfiles
                INPUT #fic, rname$
                INPUT #fic, sname$
                IF LTRIM$(RTRIM$(sname$)) = LTRIM$(RTRIM$(symname$)) THEN
                        retval$ = "DOCS\" + LTRIM$(RTRIM$(rname$))
                        EXIT FOR
                END IF
        NEXT i
        CLOSE fic
        GetFileName$ = retval$
END FUNCTION

FUNCTION GetSymName$ (catfile$, realname$)
        fic = FREEFILE
        retval$ = ""
        OPEN "docs\" + catfile$ FOR INPUT AS fic
        INPUT #fic, nbrfiles
        FOR i = 1 TO nbrfiles
                INPUT #fic, rname$
                INPUT #fic, sname$
                rname$ = LTRIM$(RTRIM$(rname$))
                sname$ = LTRIM$(RTRIM$(sname$))
                IF rname$ = LTRIM$(RTRIM$(realname$)) THEN
                        retval$ = sname$
                        EXIT FOR
                END IF
        NEXT i
        CLOSE fic
        GetSymName$ = retval$

END FUNCTION

SUB insfile (catfile$, filename$)
        fic = FREEFILE
        OPEN "docs\" + catfile$ FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\docs.tmp" FOR OUTPUT AS fic2
                        INPUT #fic, nbrfiles
                        PRINT #fic2, nbrfiles + 1

                        FOR za = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                        NEXT za
                        PRINT #fic2, filename$
                        PRINT #fic2, filename$
                CLOSE fic2
        CLOSE fic
        fic = FREEFILE
        OPEN "docs\" + catfile$ FOR OUTPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\docs.tmp" FOR INPUT AS fic2
                        INPUT #fic2, nbrfiles
                        PRINT #fic, nbrfiles
                        FOR za = 1 TO nbrfiles
                                INPUT #fic2, rname$
                                INPUT #fic2, sname$
                                PRINT #fic, rname$
                                PRINT #fic, sname$
                        NEXT za
                CLOSE fic2
        CLOSE fic
        KILL "docs\docs.tmp"
END SUB

SUB MoveToTrash (catfile$, symname$)
'On recherche le fichier dans le catalogue
        fic = FREEFILE
        retval$ = ""
        OPEN "docs\" + catfile$ FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "docs.tmp" FOR OUTPUT AS fic2
        INPUT #fic, nbrfiles
        FOR i = 1 TO nbrfiles
                INPUT #fic, rname$
                INPUT #fic, sname$
                IF LTRIM$(RTRIM$(sname$)) = LTRIM$(RTRIM$(symname$)) THEN
                        drname$ = LTRIM$(RTRIM$(rname$))
                        dsname$ = LTRIM$(RTRIM$(sname$))
                        dcname$ = LTRIM$(RTRIM$(catfile$))
                ELSE
                        PRINT #fic2, rname$
                        PRINT #fic2, sname$
                END IF
        NEXT i
        CLOSE fic
        CLOSE fic2


        IF drname$ <> "" THEN
               
                'on met a jour le catalogue
                nbrfiles = nbrfiles - 1
                fic = FREEFILE
                OPEN "docs.tmp" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\" + catfile$ FOR OUTPUT AS fic2
                        PRINT #fic2, nbrfiles

                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                        NEXT i
                CLOSE fic2
                CLOSE fic
                KILL "docs.tmp"


                'sauvegarde des donnes de la poubelle
                'plus le fichier supprime
                fic = FREEFILE
                OPEN "docs\trash.dat" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\docs.tmp" FOR OUTPUT AS fic2
                
                        INPUT #fic, nbrfiles
                        PRINT #fic2, nbrfiles + 1
                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                INPUT #fic, cname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                                PRINT #fic2, cname$
                        NEXT i
                'plus le fichier restaur
                        PRINT #fic2, drname$
                        PRINT #fic2, dsname$
                        PRINT #fic2, dcname$
                CLOSE #fic2
                CLOSE fic
                fic = FREEFILE

                'regnration de la poubelle
                OPEN "docs\docs.tmp" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\trash.dat" FOR OUTPUT AS fic2
                        INPUT #fic, nbrfiles
                        PRINT #fic2, nbrfiles
                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                INPUT #fic, cname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                                PRINT #fic2, cname$
                        NEXT i
                CLOSE #fic2
                CLOSE fic
                KILL "docs\docs.tmp"
        END IF

END SUB

SUB RemoveFile (symname$)
        fic = FREEFILE
        retval$ = ""
        OPEN "docs\trash.dat" FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "docs.tmp" FOR OUTPUT AS fic2
        INPUT #fic, nbrfiles
        FOR i = 1 TO nbrfiles
                INPUT #fic, rname$
                INPUT #fic, sname$
                INPUT #fic, cname$
                IF LTRIM$(RTRIM$(sname$)) = LTRIM$(RTRIM$(symname$)) THEN
                        retval$ = "DOCS\" + LTRIM$(RTRIM$(rname$))
                ELSE
                        PRINT #fic2, rname$
                        PRINT #fic2, sname$
                        PRINT #fic2, cname$
                END IF
        NEXT i
        CLOSE fic
        CLOSE fic2

        IF retval$ <> "" THEN
                nbrfiles = nbrfiles - 1
                fic = FREEFILE
                OPEN "docs.tmp" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\trash.dat" FOR OUTPUT AS fic2
                        PRINT #fic2, nbrfiles
                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                INPUT #fic, cname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                                PRINT #fic2, cname$
                        NEXT i
                CLOSE fic2
                CLOSE fic
                KILL "docs.tmp"
                IF LCASE$(LEFT$(retval$, 7)) <> "http://" THEN KILL "docs\" + retval$
                
        END IF

END SUB

SUB RestoreFile (symname$)
'On recherche le fichier dans le catalogue
        fic = FREEFILE
        retval$ = ""
        OPEN "docs\trash.dat" FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "docs.tmp" FOR OUTPUT AS fic2
        INPUT #fic, nbrfiles
        FOR i = 1 TO nbrfiles
                INPUT #fic, rname$
                INPUT #fic, sname$
                INPUT #fic, cname$
                IF LTRIM$(RTRIM$(sname$)) = LTRIM$(RTRIM$(symname$)) THEN
                        drname$ = LTRIM$(RTRIM$(rname$))
                        dsname$ = LTRIM$(RTRIM$(sname$))
                        dcname$ = LTRIM$(RTRIM$(cname$))
                ELSE
                        PRINT #fic2, rname$
                        PRINT #fic2, sname$
                        PRINT #fic2, cname$
                END IF
        NEXT i
        CLOSE fic
        CLOSE fic2


        IF drname$ <> "" THEN
              
                'on met a jour le catalogue
                nbrfiles = nbrfiles - 1
                fic = FREEFILE
                OPEN "docs.tmp" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\trash.dat" FOR OUTPUT AS fic2
                        PRINT #fic2, nbrfiles

                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                INPUT #fic, cname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                                PRINT #fic2, cname$
                        NEXT i
                CLOSE fic2
                CLOSE fic
                KILL "docs.tmp"


                'sauvegarde des donnes du catalogue
                'plus le fichier supprime
                fic = FREEFILE
                OPEN "docs\" + dcname$ FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\docs.tmp" FOR OUTPUT AS fic2
               
                        INPUT #fic, nbrfiles
                        PRINT #fic2, nbrfiles + 1
                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                        NEXT i
                'plus le fichier restaur
                        PRINT #fic2, drname$
                        PRINT #fic2, dsname$
                CLOSE #fic2
                CLOSE fic
                fic = FREEFILE

                'regnration de la poubelle
                OPEN "docs\docs.tmp" FOR INPUT AS fic
                fic2 = FREEFILE
                OPEN "docs\" + dcname$ FOR OUTPUT AS fic2
                        INPUT #fic, nbrfiles
                        PRINT #fic2, nbrfiles
                        FOR i = 1 TO nbrfiles
                                INPUT #fic, rname$
                                INPUT #fic, sname$
                                PRINT #fic2, rname$
                                PRINT #fic2, sname$
                        NEXT i
                CLOSE #fic2
                CLOSE fic
                KILL "docs\docs.tmp"
        END IF


END SUB

SUB updateApp (ProgName$, ProgExec$, ProgIcon$)
Ok = 1
quit = 0
        IF LCASE$(LTRIM$(RTRIM$(ProgName$))) = "none" THEN EXIT SUB
        IF LCASE$(LTRIM$(RTRIM$(ProgExec$))) = "none" THEN EXIT SUB

        fic = FREEFILE
        OPEN "Docs\apps.dat" FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "Docs\apps.tmp" FOR OUTPUT AS fic2
                INPUT #fic, nbrapp
                FOR i = 1 TO nbrapp
                        INPUT #fic, pexec$
                        INPUT #fic, pname$
                        INPUT #fic, picon$
                        pexec$ = LCASE$(LTRIM$(RTRIM$(pexec$)))
                        pname$ = LCASE$(LTRIM$(RTRIM$(pname$)))
                        picon$ = LCASE$(LTRIM$(RTRIM$(picon$)))
                        IF (pexec$ = ProgExec$) OR (pname$ = ProgName$) THEN
                                Ok = 0
                                IF LTRIM$(RTRIM$(LCASE$(picon$))) = LTRIM$(RTRIM$(LCASE$(ProgIcon$))) THEN
                                        quit = 1
                                        EXIT FOR
                                END IF
                                picon$ = ProgIcon$
                        END IF
                        PRINT #fic2, pexec$
                        PRINT #fic2, pname$
                        PRINT #fic2, picon$
                NEXT i
                IF Ok = 1 THEN
                        PRINT #fic2, ProgExec$
                        PRINT #fic2, ProgName$
                        PRINT #fic2, ProgIcon$
                END IF
        CLOSE fic2
        CLOSE fic
        IF quit = 1 THEN EXIT SUB
        fic = FREEFILE
        OPEN "docs\apps.tmp" FOR INPUT AS fic
        fic2 = FREEFILE
        OPEN "docs\apps.dat" FOR OUTPUT AS fic2
                        PRINT #fic2, nbrapp + Ok
                        FOR i = 1 TO nbrapp + Ok
                                INPUT #fic, pexec$
                                INPUT #fic, pname$
                                INPUT #fic, picon$
                                PRINT #fic2, pexec$
                                PRINT #fic2, pname$
                                PRINT #fic2, picon$
                        NEXT i
        CLOSE fic2
        CLOSE fic
        KILL "docs\apps.tmp"
END SUB

