'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\textbox.bi'

DEFSNG A-Z
SUB Create.TextBox (textbox AS textbox, X1 AS INTEGER, Y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, initialtext AS STRING, Masque AS STRING)
	textbox.X1 = X1
	textbox.x2 = x2
	textbox.Y1 = Y1
	textbox.y2 = y2
	textbox.Text = LTRIM$(RTRIM$(initialtext))
	textbox.Focused = 0
	textbox.TextLen = LEN(LTRIM$(RTRIM$(initialtext)))
	textbox.Masque = Masque
	textbox.Changed = 0
END SUB

SUB Draw.TextBox (textbox AS textbox)
	Future.MouseOff
	Future.FILLBOX (textbox.X1), (textbox.Y1), (textbox.x2), (textbox.y2), 15
	Future.BOX (textbox.X1), (textbox.Y1), (textbox.x2), (textbox.y2), 0
	Future.BOX (textbox.X1), (textbox.Y1), (textbox.x2), (textbox.y2), (ABS(textbox.Focused = 0) * 7)
	MaxLen = (textbox.x2 - textbox.X1 - 10) / 8
	todisplay$ = LEFT$(textbox.Text, textbox.TextLen)
	IF LEN(LTRIM$(RTRIM$(textbox.Masque))) > 0 THEN todisplay$ = STRING$(LEN(todisplay$), textbox.Masque)
	IF textbox.Focused = -1 THEN todisplay$ = todisplay$ + "_"
	IF LEN(todisplay$) > MaxLen THEN todisplay$ = RIGHT$(todisplay$, MaxLen)
	Future.PRINT textbox.X1 + 5, (1 + ((textbox.y2 + textbox.Y1 - 16) / 2)), todisplay$, ABS(textbox.Focused = 0) * 7, 15
	Future.MouseOn
END SUB

SUB Manage.TextBox (textbox AS textbox)
textbox.Changed = 0
	IF MouseClicLeft AND MouseZone(textbox.X1, textbox.Y1, textbox.x2, textbox.y2) AND textbox.Focused = 0 THEN
		DO
		LOOP UNTIL INKEY$ = ""
		textbox.Focused = -1
		textbox.OldText = LTRIM$(RTRIM$(textbox.Text))
		Draw.TextBox textbox
	END IF
	IF MouseClicLeft AND NOT MouseZone(textbox.X1, textbox.Y1, textbox.x2, textbox.y2) AND textbox.Focused = -1 THEN
	      textbox.Focused = 0
	      Draw.TextBox textbox
	END IF

	IF textbox.Focused = -1 THEN
		a$ = INKEY$
		IF a$ <> "" THEN
		SELECT CASE a$
		   CASE CHR$(13)
			textbox.Focused = 0
			Draw.TextBox textbox
			IF (LTRIM$(RTRIM$(textbox.Text)) <> LTRIM$(RTRIM$(textbox.OldText))) AND (textbox.TextLen > 0) THEN textbox.Changed = -1
		   CASE CHR$(8)
			IF textbox.TextLen > 0 THEN
				textbox.Text = LEFT$(textbox.Text, textbox.TextLen - 1)
				textbox.TextLen = textbox.TextLen - 1
				Draw.TextBox textbox
			END IF

		   CASE CHR$(27)
			textbox.Focused = 0
			textbox.Text = ""
			textbox.TextLen = 0
			Draw.TextBox textbox
		   CASE ELSE
			IF ASC(a$) > 25 AND textbox.TextLen < 255 THEN
				textbox.Text = LEFT$(textbox.Text, textbox.TextLen) + a$
				textbox.TextLen = textbox.TextLen + 1
				Draw.TextBox textbox
			END IF
		   END SELECT
		END IF
	END IF
END SUB

