DECLARE FUNCTION GetDoc$ (fichier$, mode$)
DECLARE FUNCTION Embed.Qml% (mode$, fichier$, Xpos%, ypos%)

DECLARE FUNCTION Display.QML% (tableau() AS STRING, Xpos%, ypos%)

DECLARE SUB Draw.Cara (Xpos%, ypos%, cara$)
'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\button.bi'
'$INCLUDE: 'lib\cliczone.bi'
'$INCLUDE: 'lib\status.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\menu.bi'
'$INCLUDE: 'lib\graphics.bi'


DIM Menu(0 TO 2, 0 TO 3) AS STRING
DIM SHARED winx1 AS INTEGER, winx2 AS INTEGER, winy1 AS INTEGER, winy2 AS INTEGER
DIM SHARED firstline AS INTEGER
DIM SHARED nbrline AS INTEGER
DIM SHARED MaxLine AS INTEGER
DIM SHARED MaxCol AS INTEGER
DIM assenceurlen AS INTEGER
DEF fnup$ = CHR$(0) + CHR$(&H48)
DEF fndown$ = CHR$(&H0) + CHR$(&H50)
DIM UpBtn AS Button
DIM DownBtn AS Button

DIM SHARED bgcolor AS INTEGER
DIM SHARED fgcolor AS INTEGER
DIM SHARED bbgcolor AS INTEGER
DIM SHARED bfgcolor AS INTEGER

DIM Xpos AS INTEGER
DIM ypos AS INTEGER

Menu(1, 0) = "FILE"
        Menu(1, 1) = "Exit"
        Menu(1, 3) = ""
Menu(2, 0) = ""
xres = 640
yres = 480
winx = 613
winy = 356
winx1 = (xres - winx) / 2
winy1 = ((yres - winy) / 2) + 15
winx2 = winx1 + winx
winy2 = winy1 + winy
MaxLine = ((winy2 - winy1 - 20) \ 16) + 1
MaxCol = ((winx2 - winx1 - 45) \ 8)
DIM stack(0 TO 300) AS STRING
DIM SHARED NbrUrl AS INTEGER
DIM SHARED Urls(1 TO 10) AS ClicZone
DIM SHARED links(1 TO 10) AS STRING

assenceurlen = ((winy2 - 29) - (winy1 + 29))
SetScreenMode xres, yres, 8

Future.MouseOff
Future.CLS 150
Draw.MenuBar Menu()
Draw.Frame winx1, winy1 - 30, winx2, winy2
DIM aUrl AS TextBox
Future.FILLBOX (winx1 + 8), (winy1 - 22), winx2 - 8, winy1 + 7, 28
Create.TextBox aUrl, winx1 + 60, winy1 - 17, winx2 - 20, winy1 + 2, "", ""
Draw.Frame3 aUrl.x1 - 1, aUrl.y1 - 1, aUrl.x2 + 1, aUrl.y2 + 1, -1, 8, 15
Draw.TextBox aUrl
Future.LINE (winx1 + 8), winy1 + 7, winx2 - 8, winy1 + 7, 0, -1
Future.PRINT (winx1 + 15), (winy1 - 14), "URL :", 0, 28
Future.FILLBOX (winx2 - 29), (winy1 + 8), (winx2 - 8), (winy2 - 8), 28
Future.LINE (winx2 - 29), (winy1 + 8), (winx2 - 29), (winy2 - 8), 0, -1
create.button UpBtn, winx2 - 28, winy1 + 8, winx2 - 8, winy1 + 28, ""
create.button DownBtn, winx2 - 28, winy2 - 28, winx2 - 8, winy2 - 8, ""
draw.Button UpBtn
draw.Button DownBtn
Draw.StatusBar ""
Future.MouseON
EditMode = 0

filename$ = "test.qml"
Draw.StatusBar filename$
DIM SHARED repertoire$
repertoire$ = ""
filename$ = GetDoc$(COMMAND$, "LOAD")
IF filename$ <> "" THEN GOSUB LoadFile

SelUrl = 0
DO
        a$ = ""
        Manage.TextBox aUrl
        IF aUrl.Changed THEN
                        a$ = GetDoc(LEFT$(aUrl.text$, aUrl.TextLen), "LOAD")
                        IF a$ <> "" THEN
                                filename$ = a$
                                GOSUB LoadFile
                        END IF
        END IF
        Manage.Button UpBtn
        Manage.Button DownBtn
        IF NOT menufocused THEN a$ = INKEY$
        HoverUrl = 0
        FOR i = 1 TO NbrUrl
                manage.ClicZone Urls(i)
                IF Urls(i).Cliqued THEN
                        a$ = GetDoc(links(i), "LOAD")
                        IF a$ <> "" THEN
                                filename$ = a$
                                GOSUB LoadFile
                        END IF
                END IF
                IF MouseZone(Urls(i).x1, Urls(i).y1, Urls(i).x2, Urls(i).y2) THEN HoverUrl = i
        NEXT i
        IF SelUrl <> HoverUrl THEN
                IF HoverUrl = 0 THEN
                        Draw.StatusBar ""
                ELSE
                        Draw.StatusBar links(HoverUrl)
                END IF
                SelUrl = HoverUrl
        END IF
        IF UpBtn.Cliqued OR a$ = fnup$ THEN
                IF firstline > 0 THEN
                        IF EditMode = -1 THEN OldFirstLine = firstline
                        firstline = firstline - 1
                        GOSUB RedrawText
                END IF
        END IF
        IF DownBtn.Cliqued OR a$ = fndown$ THEN
                IF firstline + MaxLine - 1 < nbrline THEN
                        IF EditMode = -1 THEN OldFirstLine = firstline

                        firstline = firstline + 1
                        GOSUB RedrawText
                END IF
        END IF




        Manage.Menu Menu()
LOOP UNTIL Menu(0, 1) = "Exit"
Future.MouseOff
ReSetScreen
END









RedrawText:
        Future.MouseOff
        Future.FILLBOX winx1 + 8, winy1 + 8, winx2 - 30, winy2 - 8, 15
        NbrUrl = 0
        nbrline = Display.QML(stack(), 0, firstline)
        GOSUB drawAssenceur
        Future.MouseON
RETURN

drawAssenceur:
        IF nbrline > 0 THEN
                percent = ((MaxLine - 1) / nbrline * assenceurlen)
                firstpos = firstline / nbrline * assenceurlen
                IF percent > assenceurlen THEN percent = assenceurlen
                IF firstpos + percent > assenceurlen THEN percent = assenceurlen - firstpos
        ELSE
                percent = assenceurlen
                firstpos = 0
        END IF
        Future.MouseOff
        Future.FILLBOX (winx2 - 29), (winy1 + 29), (winx2 - 8), (winy2 - 28), 25
        Draw.Frame3 (winx2 - 28), (winy1 + 29 + firstpos), (winx2 - 8), (winy1 + 28 + firstpos + percent), 7, 15, 8
        Future.MouseON
RETURN


LoadFile:
        aUrl.text$ = filename$
        aUrl.TextLen = LEN(filename$)
        Draw.TextBox aUrl
        fic = FREEFILE
        nbrline = 0
        StackPos(nbrline) = 0
        stack(nbrline) = ""
        ERASE stack
        OPEN filename$ FOR INPUT AS fic
                nbrline = 0
                WHILE NOT EOF(fic)
                        LINE INPUT #fic, stack(i)
                        i = i + 1
                WEND
        CLOSE fic
        firstline = 0
        fgcolor = 0
        bgcolor = 15
        bfgcolor = 0
        bbgcolor = 15
        GOSUB RedrawText
        Draw.StatusBar filename$
RETURN

FUNCTION Display.QML (tableau() AS STRING, Xpos, ypos)

axpos = 0
aypos = 0
        Future.MouseOff
        FOR i = 0 TO UBOUND(tableau)
           
                chaine$ = LTRIM$(RTRIM$(tableau(i)))
                cmd$ = UCASE$(LEFT$(chaine$, 1))
                contenu$ = ""
                IF LEN(chaine$) > 1 THEN contenu$ = MID$(chaine$, 2)
                SELECT CASE cmd$
                        CASE "$"
                        'display text
                                kk = MaxCol - axpos - 1
                                IF kk < 5 THEN
                                        axpos = 0
                                        aypos = aypos + 1
                                        kk = MaxCol - 1
                                END IF
                                WHILE LEN(contenu$) >= kk
                                                t$ = LEFT$(contenu$, kk - 1) + "-"
                                                zz$ = t$ + STRING$(MaxCol - LEN(t$) - axpos, " ")
                                                IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN Future.PRINT (winx1 + 10 + (axpos * 8)), (winy1 + 8 + ((aypos - ypos) * 16)), t$, (fgcolor), (bgcolor)
                                                aypos = aypos + 1
                                                axpos = 0
                                                contenu$ = MID$(contenu$, kk)
                                                kk = MaxCol - 1
                                WEND
                                contenu$ = contenu$ + " "
                                IF LEN(contenu$) < MaxCol - axpos THEN
                                        zz$ = contenu$ + STRING$(MaxCol - LEN(contenu$) - axpos, " ")
                                ELSE
                                        zz$ = contenu$
                                END IF
                                IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN Future.PRINT (winx1 + 10 + (axpos * 8)), (winy1 + 8 + ((aypos - ypos) * 16)), zz$, (fgcolor), (bgcolor)
                                axpos = axpos + LEN(contenu$)
                        CASE "C"
                        'display ascci character
                          IF contenu$ <> "" THEN
                                IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN Future.PRINT (winx1 + 10 + (axpos * 8)), (winy1 + 8 + ((aypos - ypos) * 16)), CHR$(VAL(contenu$)), (fgcolor), (bgcolor)
                          END IF
                          axpos = axpos + 1
                          
                        CASE "|"
                        'line break
                                aypos = aypos + 1
                                axpos = 0
                                IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN Future.PRINT (winx1 + 10), (winy1 + 8 + ((aypos - ypos) * 16)), STRING$(MaxCol, " "), (fgcolor), (bgcolor)
                                'multiple line break
                                WHILE LEN(contenu$) > 0
                                        IF LEFT$(contenu$, 1) = "|" THEN
                                                aypos = aypos + 1
                                              IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN Future.PRINT (winx1 + 10), (winy1 + 8 + ((aypos - ypos) * 16)), STRING$(MaxCol - 1, " "), (fgcolor), (bgcolor)
                                        END IF
                                        contenu$ = MID$(contenu$, 2)
                                WEND
                        CASE "="
                        'horizontal rule
                                axpos = 0
                                aypos = aypos + 1
                                IF contenu$ = "" THEN
                                        l% = MaxCol
                                        zz$ = STRING$(l%, "-")
                                ELSE
                                        l% = VAL(contenu$)
                                        IF l% > MaxCol THEN l% = MaxCol
                                        zz$ = STRING$(l%, "-") + STRING$(MaxCol - l%, " ")
                                END IF
                                IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN Future.PRINT (winx1 + 10 + (axpos * 8)), (winy1 + 8 + ((aypos - ypos) * 16)), zz$, (fgcolor), (bgcolor)
                                axpos = axpos + l% + 1
                                
                        CASE "#"
                        'change foreground color
                                IF contenu$ <> "" THEN
                                        fgcolor = VAL(contenu$)
                                ELSE
                                        fgcolor = bfgcolor
                                END IF
                        CASE ":"
                        'change background color
                                IF contenu$ <> "" THEN
                                        bgcolor = VAL(contenu$)
                                ELSE
                                        bgcolor = bbgcolor
                                END IF
                       
                        CASE "F"
                        'set default foreground
                                bfgcolor = VAL(contenu$)
                        CASE "B"
                        'set default background
                                bbgcolor = VAL(contenu$)
                        CASE "_"
                        'insert hyperlink
                        IF contenu$ <> "" AND LEN(contenu$) > 3 THEN
                                IF (aypos >= ypos) AND (aypos + 2 <= ypos + MaxLine) THEN
                                   FOR z = 1 TO LEN(contenu$)
                                        IF MID$(contenu$, z, 1) = ">" THEN
                                                texte$ = LEFT$(contenu$, z - 1)
                                                texte$ = " " + texte$ + " "
                                                Url$ = MID$(contenu$, z + 1)
                                                EXIT FOR
                                        END IF
                                   NEXT z
                                   IF texte$ <> "" THEN
                                        NbrUrl = NbrUrl + 1
                                        create.cliczone Urls(NbrUrl), (winx1 + 10 + (axpos * 8)), (winy1 + 8 + ((aypos - ypos) * 16)), (winx1 + 12 + (axpos * 8) + LEN(texte$) * 8), (winy1 + 24 + ((aypos - ypos) * 16)), 15, 1
                                        Future.PRINT (winx1 + 10 + (axpos * 8)), (winy1 + 8 + ((aypos - ypos) * 16)), texte$, 1, 15
                                        Future.LINE Urls(NbrUrl).x1, Urls(NbrUrl).y2 - 1, Urls(NbrUrl).x2, Urls(NbrUrl).y2 - 1, 1, -1
                                        draw.ClicZone Urls(NbrUrl)
                                        Future.MouseOff
                                        axpos = axpos + LEN(texte$) + 1
                                        links(NbrUrl) = Url$
                                   END IF
                                END IF
                                'axpos = 0
                                'aypos = aypos + 1
                        END IF
                        CASE "^"
                        'insert download link

                        CASE CHR$(34) ' = "
                        'embed text file
                        IF contenu$ <> "" THEN
                                aypos = aypos + Embed.Qml("TXT", contenu$, axpos, (ypos - aypos))
                        END IF
                        CASE "+"
                        'embed qml
                        IF contenu$ <> "" THEN
                                aypos = aypos + Embed.Qml("QML", contenu$, axpos, (ypos - aypos))
                        END IF
                END SELECT
                IF axpos >= MaxCol THEN
                        axpos = 0
                        aypos = aypos + 1
                END IF
        NEXT i

        Future.MouseON
        Display.QML = aypos + 1
END FUNCTION

SUB Draw.Cara (Xpos%, ypos%, cara$)
        Future.MouseOff
        Future.PRINT (winx1 + 10 + (Xpos% * 8)), (winy1 + 10 + (ypos% * 16)), MID$(cara$, 1, 1), 0, 15
        Future.MouseON
END SUB

FUNCTION Embed.Qml (mode$, fichier$, Xpos, ypos)
STATIC z AS INTEGER
        finame$ = GetDoc$(fichier$, "EMBED")
        IF finame$ = "" THEN
                Embed.Qml = 0
                EXIT FUNCTION
        END IF
        DIM Memoire(0 TO 100) AS STRING
        fic = FREEFILE
        Memoire(0) = ""
        OPEN finame$ FOR INPUT AS fic
                nbrline = 0
                WHILE NOT EOF(fic)
                        LINE INPUT #fic, Memoire(i)
                        IF UCASE$(mode$) = "TXT" THEN
                                Memoire(i) = "$" + LTRIM$(RTRIM$(Memoire(i)))
                                Memoire(i + 1) = "|"
                                i = i + 1
                        END IF
                        i = i + 1
                WEND
        CLOSE fic
        Embed.Qml = Display.QML(Memoire(), Xpos, ypos)
END FUNCTION

FUNCTION GetDoc$ (fichier$, mode$)
'ce code lis le nom du fichier
'pour determiner d'o il doit le charger
'et pour mettre eventuellement a jour le nom du repertoire de travail
'si le mode est "EMBED" a veux dire que c'est une page embarque
'donc on ne mettra pas  jour le repertoire
'car la page principale peut embarquer plusieurs fichier de sites differents
'les fichiers embarqus ne peuvent pas en embarquer d'autres


'soit on doit le telecharger
        IF LCASE$(LEFT$(fichier$, 7)) = "http://" AND LEN(fichier$) > 8 THEN
                FOR i = LEN(fichier$) - 1 TO 8 STEP -1
                        IF MID$(fichier$, i, 1) = "/" THEN
                                IF mode$ <> "EMBED" THEN repertoire$ = LCASE$(LEFT$(fichier$, i))
                                array = AllocateXMS(356000)
                                future.xmsget 0, 0, 639, 479, array
                                ReSetScreen
                                SHELL "getnet " + fichier$
                                Set640x480 8
                                future.xmsput 0, 0, array
                                deallocatexms array
                                GetDoc$ = "out.dat"
                                EXIT FUNCTION
                        END IF
                NEXT i
                GetDoc$ = ""
                EXIT FUNCTION
        END IF
'soit on le prend sur le disque
        IF LEFT$(fichier$, 1) = "\" OR MID$(fichier$, 2, 2) = ":\" THEN
                FOR i = LEN(fichier$) - 1 TO 2 STEP -1
                        IF MID$(fichier$, i, 1) = "\" THEN
                                IF mode$ <> "EMBED" THEN repertoire$ = LCASE$(LEFT$(fichier$, i))
                                GetDoc$ = fichier$
                                EXIT FUNCTION
                        END IF
                NEXT i
                GetDoc$ = ""
                EXIT FUNCTION
        END IF

'soit on ne sait pas
        'si il n'y a pas de repertoire alors
        'on va voir s'il faut en definir un
        IF repertoire$ = "" THEN
                'on verifie si on recherche un repertoire relatif au courrant
                FOR i = LEN(fichier$) - 1 TO 2 STEP -1
                        IF MID$(fichier$, i, 1) = "\" THEN
                                IF mode$ <> "EMBED" THEN repertoire$ = LCASE$(LEFT$(fichier$, i))
                                GetDoc$ = fichier$
                                EXIT FUNCTION
                        END IF
                NEXT i
                'si on est ici alors aucun repertoire n'a ete defini
                'alors on renvoie le fichier depuis le repertoire courrant
                GetDoc$ = fichier$
                EXIT FUNCTION
        ELSE

        'si un repertoire a ete defini, on va voir quel est le repertoire
                'si le repertoire est distant on telecharge le fichier
                IF LCASE$(LEFT$(repertoire$, 7)) = "http://" THEN
                'on va voir s'il faut mettre a jour le repertoire
                                array = AllocateXMS(356000)
                                future.xmsget 0, 0, 639, 479, array
                                ReSetScreen
                                SHELL "getnet " + repertoire$ + fichier$
                                Set640x480 8
                                future.xmsput 0, 0, array
                                deallocatexms array


                        IF mode$ <> "EMBED" THEN
                                FOR i = LEN(fichier$) - 1 TO 2 STEP -1
                                        IF MID$(fichier$, i, 1) = "/" THEN
                                                repertoire$ = repertoire$ + LCASE$(LEFT$(fichier$, i))
                                        END IF
                                NEXT i
                        END IF
                        GetDoc$ = "out.dat"
                        EXIT FUNCTION
                END IF
                              
                'si on est ici c'est que le repertoire est sur le disque
                        a$ = repertoire$ + fichier$
                        IF mode$ <> "EMBED" THEN
                                'on met a jour le repertoire
                                FOR i = LEN(fichier$) - 1 TO 2 STEP -1
                                        IF MID$(fichier$, i, 1) = "\" THEN
                                                repertoire$ = repertoire$ + LCASE$(LEFT$(fichier$, i))
                                        END IF
                                NEXT i
                        END IF
                        GetDoc$ = a$
                        EXIT FUNCTION
        END IF
END FUNCTION

