DECLARE SUB LoadDocs ()
DECLARE FUNCTION Manage.Files% ()
DECLARE SUB Draw.Title (Text$)
DECLARE SUB DrawFiles ()
DECLARE SUB Disable.button (button AS ANY)
DECLARE SUB Enable.button (button AS ANY)
DECLARE FUNCTION ManageClasses% ()
DECLARE SUB DrawCats ()
DECLARE SUB LoadCats ()
DECLARE SUB dither (x1%, y1%, x2%, y2%, c%)
DECLARE SUB Draw.Frame (x1%, y1%, x2%, y2%)

'$INCLUDE: 'future.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\button.bi'
'$INCLUDE: 'lib\cliczone.bi'
'$INCLUDE: 'lib\status.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\fselect.bi'
'$INCLUDE: 'lib\menu.bi'
'$INCLUDE: 'lib\graphics.bi'
'$INCLUDE: 'lib\fs.bi'
'$INCLUDE: 'lib\xpm.bi'
TYPE DocClass
        symname AS STRING * 20
        appname AS STRING * 50
        iconfile AS STRING * 20
        Catfile AS STRING * 20
END TYPE

TYPE Document
        realname AS STRING * 80
        symname AS STRING * 80
        icone AS STRING * 30
END TYPE

DIM SHARED Classes(1 TO 20) AS DocClass
DIM SHARED Documents(1 TO 40) AS Document
DIM SHARED nbrclass AS INTEGER
DIM SHARED firstclass AS INTEGER
DIM SHARED PressedClass AS INTEGER
DIM SHARED nbrfiles AS INTEGER
DIM SHARED firstfile AS INTEGER
DIM SHARED PressedFile AS INTEGER


DIM Menu(0 TO 3, 0 TO 2) AS STRING
DIM SHARED IconesClic(0 TO 11) AS clicZone
Menu(1, 0) = "FILE"
        Menu(1, 1) = "EXIT"
        Menu(1, 2) = ""
Menu(2, 0) = "System"
        Menu(2, 1) = "Check Updates"
        Menu(2, 2) = ""
Menu(3, 0) = ""

DIM BackButton AS button
DIM OpenButton AS button
DIM RemoveButton AS button
DIM CreateButton AS button
DIM NextButton AS button
DIM PrevButton AS button
create.button BackButton, 65, 350, 155, 375, "Back"
create.button OpenButton, 475, 350, 575, 375, "Open"
create.button RemoveButton, 365, 350, 465, 375, "Remove"
create.button CreateButton, 255, 350, 355, 375, "Create"
create.button PrevButton, 551, 40, 570, 60, "<"
create.button NextButton, 571, 40, 590, 60, ">"
FOR I% = 0 TO 11
        X% = I% MOD 4
        Y% = I% \ 4
        create.cliczone IconesClic(I%), (120 + (X% * 120)), (95 + (Y% * 80)), (170 + (X% * 120)), (145 + (Y% * 80)), 15, 1
NEXT I%

xres = 640
yres = 480
SetScreenMode xres, yres, 8
SetMouseMaskColor 3 'set transparent color to 0
RESTORE MouseShape
FOR I% = 0 TO 255 'copy mouse shape DATA into a string
READ a%
c$ = c$ + CHR$(a%)
NEXT
Future.MouseShape SADD(c$), VARSEG(c$)'parse DATA string to the mouse

LoadCats

Future.MouseOff
Future.CLS 150
Draw.MenuBar Menu()
Draw.StatusBar ""
Draw.Frame 50, 70, 589, 390
Future.FILLBOX 58, 343, 581, 382, 28
Future.LINE 58, 343, 581, 343, 0, -1
Draw.Frame3 BackButton.x1 - 1, BackButton.y1 - 1, BackButton.x2 + 1, BackButton.y2 + 1, -1, 20, 30
Draw.Frame3 CreateButton.x1 - 1, CreateButton.y1 - 1, CreateButton.x2 + 1, CreateButton.y2 + 1, -1, 20, 30
Draw.Frame3 OpenButton.x1 - 1, OpenButton.y1 - 1, OpenButton.x2 + 1, OpenButton.y2 + 1, -1, 20, 30
Draw.Frame3 RemoveButton.x1 - 1, RemoveButton.y1 - 1, RemoveButton.x2 + 1, RemoveButton.y2 + 1, -1, 20, 30

draw.button BackButton
draw.button CreateButton
draw.button OpenButton
draw.button RemoveButton
draw.button NextButton
draw.button PrevButton

Future.MouseOn

lview = 0
firstclass = 1
PressedClass = 0
DrawCats
Disable.button BackButton
Disable.button CreateButton
Disable.button OpenButton
Disable.button RemoveButton
Disable.button PrevButton
Disable.button NextButton
DO

        Manage.Menu Menu()
        manage.button BackButton
        manage.button CreateButton
        manage.button OpenButton
        manage.button RemoveButton
        manage.button NextButton
        manage.button PrevButton

        IF NextButton.Cliqued THEN
                firstfile = firstfile + 1
                IF firstfile + 11 = nbrfiles THEN
                        Disable.button NextButton
                END IF
                Enable.button PrevButton
                DrawFiles
        END IF
        IF PrevButton.Cliqued THEN
                firstfile = firstfile - 1
                IF firstfile = 1 THEN
                        Disable.button PrevButton
                END IF
                Enable.button NextButton
                DrawFiles
        END IF

        IF CreateButton.Cliqued THEN
                IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "TRASH" THEN
                        'Suppression de tout les fichiers
                        ClearTrash
                        GOSUB reloadFiles
                ELSE
                        a$ = ""
                        fic = FREEFILE
                        OPEN "docs\cmd.tmp" FOR OUTPUT AS fic
                        PRINT #fic, a$
                        CLOSE fic
                        B$ = LTRIM$(RTRIM$(Classes(PressedClass).appname))
                        ReSetScreen
                        CHAIN B$
                END IF
        END IF
        IF OpenButton.Cliqued THEN
                IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "TRASH" THEN
                'restuaration
                        a$ = LTRIM$(RTRIM$(Documents(SelectedFile).symname))
                        RestoreFile a$
                        GOSUB reloadFiles
                ELSE
                        IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "APPLICATIONS" THEN
                                'ouverture
                                a$ = "APPS\" + LTRIM$(RTRIM$(Documents(SelectedFile).realname))
                                B$ = ""
                                fic = FREEFILE
                                OPEN "docs\cmd.tmp" FOR OUTPUT AS fic
                                        PRINT #fic, B$
                                CLOSE fic
                                ReSetScreen
                                CHAIN a$
                        ELSE
                                'ouverture
                                a$ = "DOCS\" + LTRIM$(RTRIM$(Documents(SelectedFile).realname))
                                fic = FREEFILE
                                OPEN "docs\cmd.tmp" FOR OUTPUT AS fic
                                        PRINT #fic, a$
                                CLOSE fic
                                B$ = LTRIM$(RTRIM$(Classes(PressedClass).appname))
                                ReSetScreen
                                CHAIN B$
                        END IF
                END IF
        END IF
        IF RemoveButton.Cliqued THEN
                a$ = LTRIM$(RTRIM$(Documents(SelectedFile).symname))

                IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "TRASH" THEN
                        RemoveFile a$
                ELSE
                        MoveToTrash Classes(PressedClass).Catfile, a$
                END IF
                GOSUB reloadFiles
        END IF

        IF BackButton.Cliqued THEN
                Disable.button BackButton
                Disable.button CreateButton
                Disable.button OpenButton
                Disable.button RemoveButton
                Disable.button PrevButton
                Disable.button NextButton
                IF SelectedFile > 0 THEN
                        SWAP IconesClic(SelectedFile - firstfile).c1, IconesClic(SelectedFile - firstfile).c2
                END IF
                IF nbrclass > 12 THEN Enable.button NextButton
                PressedFile = 0
                SelectedFile = 0
                PressedClass = 0
                firstclass = 1
                DrawCats
        END IF
        IF PressedClass = 0 THEN
               PressedClass = ManageClasses
               IF PressedClass THEN
                        'afficher les fichier selectionnes
                        Draw.StatusBar ""
                        PressedFile = 0
                        firstfile = 1
                        LoadDocs
                        IF c% <> 255 THEN Future.PSET x1% + X%, y1% + Y%, c%
                        OpenButton.Text = "Open"
                        CreateButton.Text = "Create"
                        Enable.button CreateButton
                        Enable.button BackButton
                        IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "TRASH" THEN
                                OpenButton.Text = "Restore"
                                CreateButton.Text = "Empty"
                        END IF
                        IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "APPLICATIONS" THEN
                                OpenButton.Text = "EXECUTE"
                                Disable.button CreateButton
                        END IF
                        draw.button CreateButton
                        draw.button OpenButton
                        IF nbrfiles > 12 THEN Enable.button NextButton
                        DrawFiles
                END IF
        ELSE
                'manager les icones des fichiers
                ap = Manage.Files
                IF ap THEN
                       IF PressedFile > 0 THEN
                                SWAP IconesClic(PressedFile - firstfile).c1, IconesClic(PressedFile - firstfile).c2
                                draw.ClicZone IconesClic(PressedFile - firstfile)
                       END IF
                       PressedFile = ap
                       SWAP IconesClic(PressedFile - firstfile).c1, IconesClic(PressedFile - firstfile).c2
                       draw.ClicZone IconesClic(PressedFile - firstfile)

                        Enable.button OpenButton
                        IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) <> "APPLICATIONS" THEN Enable.button RemoveButton
                        SelectedFile = PressedFile
                END IF
        END IF
        IF Menu(0, 1) = "Check Updates" THEN
                ReSetScreen
                CHAIN "apps\updater.exe"
        END IF
LOOP UNTIL Menu(0, 1) = "EXIT"
Future.MouseOff
ReSetScreen
END





reloadFiles:
                        LoadDocs
                        IF SelectedFile > 0 THEN
                                SWAP IconesClic(SelectedFile - firstfile).c1, IconesClic(SelectedFile - firstfile).c2
                                draw.ClicZone IconesClic(SelectedFile - firstfile)
                        END IF
                        IF nbrfiles <= 12 THEN Disable.button NextButton
                        PressedFile = 0
                        firstfile = 1
                        SelectedFile = 0
                        Disable.button OpenButton
                        Disable.button RemoveButton
                        DrawFiles

RETURN

'Cursor data
MouseShape:
DATA 0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3
DATA 0,7,0,3,3,3,3,3,3,3,3,3,3,3,3,3
DATA 0,7,7,0,3,3,3,3,3,3,3,3,3,3,3,3
DATA 0,8,7,7,0,3,3,3,3,3,3,3,3,3,3,3
DATA 0,8,7,7,7,0,3,3,3,3,3,3,3,3,3,3
DATA 0,8,8,7,7,7,0,3,3,3,3,3,3,3,3,3
DATA 0,8,8,7,7,7,7,0,3,3,3,3,3,3,3,3
DATA 0,8,8,8,7,7,7,7,0,3,3,3,3,3,3,3
DATA 0,8,8,8,7,7,7,7,7,0,3,3,3,3,3,3
DATA 0,8,8,8,8,7,0,0,0,0,3,3,3,3,3,3
DATA 0,8,8,0,8,7,0,3,3,3,3,3,3,3,3,3
DATA 0,8,0,3,0,8,7,0,3,3,3,3,3,3,3,3
DATA 0,0,3,3,0,8,7,0,3,3,3,3,3,3,3,3
DATA 3,3,3,3,3,0,8,7,0,3,3,3,3,3,3,3
DATA 3,3,3,3,3,0,8,7,0,3,3,3,3,3,3,3
DATA 3,3,3,3,3,3,0,0,0,3,3,3,3,3,3,3

SUB dither (x1%, y1%, x2%, y2%, c%)
        FOR Y% = y1% TO y2%
                Future.LINE x1% + (Y% MOD 2), Y%, x2%, Y%, c%, &HAAAA
                
        NEXT Y%
END SUB

SUB Draw.Title (Text$)
        FOR I = 0 TO 20
                Future.LINE 50, 40 + I, 550, 40 + I, (30 - (I * .4)), -1
        NEXT I
        Future.BOX 50, 40, 550, 60, 0
        Future.PRINT 60, 43, LTRIM$(RTRIM$(Text$)), 0, -1

END SUB

SUB DrawCats
        Future.MouseOff
        icone$ = GetFileName("Ficon.dat", "background")
        Future.FILLBOX 60, 80, 579, 340, 15
        LoadXPM icone$, 542, 303
        icone$ = GetFileName("Ficon.dat", "folder")
        Draw.Title "Home Folder"
        IF firstclass = 0 OR nbrclass = 0 THEN EXIT SUB
        x1% = 50
        y1% = 70
        x2% = 589
        y2% = 409
        j% = nbrclass - firstclass
        IF j% > 11 THEN j% = 11
        FOR I% = 0 TO j%
                X% = I% MOD 4
                Y% = I% \ 4
                k% = I% + firstclass
                draw.ClicZone IconesClic(I%)
                a$ = LTRIM$(RTRIM$(Classes(k%).symname))
                IF LEN(a$) > 14 THEN a$ = LEFT$(a$, 11) + "..."
                ifile$ = icone$
                IF UCASE$(a$) = "TRASH" THEN ifile$ = GetFileName("ficon.dat", "trash")
                IF UCASE$(a$) = "APPLICATIONS" THEN ifile$ = GetFileName("ficon.dat", "appfolder")
                IF UCASE$(a$) = "ONLINE APPS" THEN ifile$ = GetFileName("ficon.dat", "netfolder")
                LoadXPM ifile$, IconesClic(I%).x1 + 5, IconesClic(I%).y1 + 5
                Future.PRINT (x1 + ((X% * 120) + 95 - (LEN(a$) * 4))), (y1 + 80 + (Y% * 80)), a$, 0, 15
        NEXT I
        Future.MouseOn
END SUB

SUB DrawFiles
        Future.MouseOff
        Future.FILLBOX 60, 80, 579, 340, 15
        Draw.Title Classes(PressedClass).symname
        icone$ = GetFileName("Ficon.dat", "background")
        Future.FILLBOX 60, 80, 579, 340, 15
        LoadXPM icone$, 542, 303
        icone$ = GetFileName("Ficon.dat", LTRIM$(RTRIM$(Classes(PressedClass).iconfile)))

        IF firstfile = 0 OR nbrfiles = 0 THEN EXIT SUB
        x1% = 50
        y1% = 70
        x2% = 589
        y2% = 409
        j% = nbrfiles - firstfile
        IF j% > 11 THEN j% = 11
        Future.MouseOn
        FOR I% = 0 TO j%
                X% = I% MOD 4
                Y% = I% \ 4
                k% = I% + firstfile
                IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "ICONFILE" THEN
                        icone$ = "DOCS\" + LTRIM$(RTRIM$(Documents(k%).realname))
                END IF
                IF UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname))) = "APPLICATIONS" THEN
                        icone$ = GetFileName("ficon.dat", LTRIM$(RTRIM$(Documents(k%).icone)))
                END IF

                draw.ClicZone IconesClic(I%)
                a$ = LTRIM$(RTRIM$(Documents(k%).symname))
                IF LEN(a$) > 14 THEN a$ = LEFT$(a$, 11) + "..."
                Future.MouseOff
                Future.PRINT (x1 + ((X% * 120) + 95 - (LEN(a$) * 4))), (y1 + 80 + (Y% * 80)), a$, 0, 15
                IF icone$ <> "" THEN LoadXPM icone$, IconesClic(I%).x1 + 5, IconesClic(I%).y1 + 5
                Future.MouseOn
        NEXT I

        
END SUB

SUB LoadCats
fic = FREEFILE
OPEN "docs\cats.dat" FOR INPUT AS fic
        INPUT #fic, nbrclass
        IF nbrclass > 20 THEN nbrclass = 20
        'IF nbrclass > 0 THEN REDIM Classes(1 TO nbrclass) AS DocClass
        FOR I = 1 TO nbrclass
                INPUT #fic, Classes(I%).symname
                INPUT #fic, Classes(I%).appname
                INPUT #fic, Classes(I%).iconfile
                INPUT #fic, Classes(I%).Catfile
        NEXT I
CLOSE fic
END SUB

SUB LoadDocs
fic = FREEFILE
a$ = UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).Catfile)))
B$ = UCASE$(LTRIM$(RTRIM$(Classes(PressedClass).symname)))

OPEN "docs\" + a$ FOR INPUT AS fic
        INPUT #fic, nbrfiles
        IF nbrfiles > 50 THEN nbrfiles = 50
        'IF nbrfiles > 0 THEN REDIM Documents(1 TO nbrfiles) AS Document

        FOR I = 1 TO nbrfiles
                INPUT #fic, Documents(I%).realname
                INPUT #fic, Documents(I%).symname
                'si on est dans la poubelle, ya une troisieme ligne qu'on peut ignorer
                IF B$ = "TRASH" THEN INPUT #fic, nothing$
                IF B$ = "APPLICATIONS" THEN INPUT #fic, Documents(I%).icone
        NEXT I
CLOSE fic

END SUB

FUNCTION Manage.Files
        IF nbrfiles = 0 THEN EXIT FUNCTION
        STATIC HoverFile
        STATIC Hf
        Manage.Files = 0
                j% = nbrfiles - firstfile
                IF j% > 11 THEN j% = 11

                FOR I% = 0 TO j%
                        manage.ClicZone IconesClic(I%)
                        IF IconesClic(I%).Cliqued AND PressedFile <> I% + firstfile THEN
                                Manage.Files = I% + firstfile
                                EXIT FUNCTION
                        END IF
                        IF MouseZone(IconesClic(I%).x1, IconesClic(I%).y1, IconesClic(I%).x2, IconesClic(I%).y2) AND HoverFile <> I% + 1 THEN
                                HoverFile = I% + 1
                                Hf = 1
                                Draw.StatusBar "File://" + LTRIM$(RTRIM$(Documents(I% + firstfile).symname)) + " (" + LTRIM$(RTRIM$(Documents(I% + firstfile).realname)) + ")"
                        END IF

                NEXT I
                IF HoverFile THEN
                        IF Hf = 1 AND NOT MouseZone(IconesClic(HoverFile - 1).x1, IconesClic(HoverFile - 1).y1, IconesClic(HoverFile - 1).x2, IconesClic(HoverFile - 1).y2) THEN
                                Draw.StatusBar ""
                                HoverFile = 0
                                Hf = 0
                        END IF
                END IF

END FUNCTION

FUNCTION ManageClasses
        IF nbrclass = 0 THEN EXIT FUNCTION
        STATIC HoverClass
        STATIC Hc
        ManageClasses = 0
                j% = nbrclass - firstclass
                IF j% > 11 THEN j% = 11
                FOR I% = 0 TO j%
                        manage.ClicZone IconesClic(I%)
                        IF IconesClic(I%).Cliqued THEN
                                ManageClasses = I% + firstclass
                                EXIT FUNCTION
                        END IF
                        IF MouseZone(IconesClic(I%).x1, IconesClic(I%).y1, IconesClic(I%).x2, IconesClic(I%).y2) AND HoverClass <> I% + 1 THEN
                                HoverClass = I% + 1
                                Hc = 1
                                Draw.StatusBar "Class://" + LTRIM$(RTRIM$(Classes(I% + firstclass).symname)) + " (" + LTRIM$(RTRIM$(Classes(I% + firstclass).Catfile)) + ")"
                        END IF

                NEXT I
                IF HoverClass THEN
                        IF Hc = 1 AND NOT MouseZone(IconesClic(HoverClass - 1).x1, IconesClic(HoverClass - 1).y1, IconesClic(HoverClass - 1).x2, IconesClic(HoverClass - 1).y2) THEN
                                Draw.StatusBar ""
                                HoverClass = 0
                                Hc = 0
                        END IF
                END IF

END FUNCTION

